C  ---------------------------------------------------------------------
      FUNCTION FUNMIN ( X,N )
C  ---------------------------------------------------------------------
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
      X1 = X(1)
      X2 = X(2)
      FUNMIN = (4 - 2.1*X1**2 + X1**4/3)*X1**2 +
     &         X1*X2 + (-4 + 4*X2**2)*X2**2
      END
C  ---------------------------------------------------------------------
      SUBROUTINE GRANAL ( N, X, GRAD )
C  ---------------------------------------------------------------------
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), GRAD(N)
      GRAD(1) = 8*X(1) - 8.4*X(1)**3 + 2*X(1)**5 + X(2)
      GRAD(2) = X(1) - 8*X(2) + 16*X(2)**3
      END
C  ---------------------------------------------------------------------
      SUBROUTINE HANAL ( H, LD, N, X )
C  ---------------------------------------------------------------------
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION H(LD,N), X(N)
      H(1,1) = 8 - 25.2*X(1)**2 + 10*X(1)**4
      H(2,1) = 1
      H(2,2) = 48*X(2)**2 - 8
      END
